/* convers server - based on conversd written by DK5SG
 * ported to WNOS by DB3FL - 9109xx/9110xx
 * ported to NOS by PE1NMB - 920120
 * Mods by PA0GRI
 * Cleanup, and additional mods by WG7J
 * additional mods by N2RJT & WA2ZKD 921206, folded into JNOS108C 930318
 */

#include <time.h>
#include <ctype.h>
#include <string.h>
#ifdef  UNIX
#include <sys/types.h>
#include <sys/stat.h>
#endif
#ifdef MSDOS
#include <io.h>
#endif
#include "global.h"
#ifdef NOS
#include <alloc.h>
#else
#include "sockserv.h"
#define CONVERS
#endif
#ifdef CONVERS
#include "cmdparse.h"
#include "convers.h"
#ifdef NOS
#include "mailbox.h"
#include "netuser.h"
#include "pktdrvr.h"
#include "timer.h"
#include "usock.h"
#include "socket.h"
#include "session.h"
#include "files.h"
#include "mailutil.h"
#ifdef LZW
#include "lzw.h"
#endif
#else
#include <sys/socket.h>
#endif

int allow_info_updates;

struct filter_link *Filterlinks;
int FilterMode;
struct permlink *permlinks;
static char Ccall[AXALEN];

static int docinfo __ARGS((int argc,char *argv[],void *p));
static int docfilter __ARGS((int argc,char *argv[],void *p));
static int dochostname __ARGS((int argc,char *argv[],void *p));
static int dociface __ARGS((int argc,char *argv[],void *p));
static int doconfcall __ARGS((int argc,char *argv[],void *p));
static int doclink __ARGS((int argc,char *argv[],void *p));
static int docxlink __ARGS((int argc,char *argv[],void *p));
static int doclinks __ARGS((int argc,char *argv[],void *p,int lzw));
static int docunlink __ARGS((int argc,char *argv[],void *p));
static int doct4 __ARGS((int argc,char *argv[],void *p));
static int docmaxwait __ARGS((int argc,char *argv[],void *p));
static int dohmaxq __ARGS((int argc,char *argv[],void *p));
static int doumaxq __ARGS((int argc,char *argv[],void *p));
static int dotdisc __ARGS((int argc,char *argv[],void *p));


static struct cmds DFAR Ccmds[] = {
    "filter",    docfilter,   0, 0, NULLCHAR,
    "hmaxq",    dohmaxq,    0, 0, NULLCHAR,
    "hostname", dochostname,0, 0, NULLCHAR,
#ifdef NOS
    "interface",dociface,   0, 0, NULLCHAR,
#endif
    "maxwait",  docmaxwait, 0, 0, NULLCHAR,
#ifdef AX25
    "mycall",   doconfcall, 0, 0, NULLCHAR,
#endif
#ifdef LINKS
    "link",     doclink,    0, 0, NULLCHAR,
    "unlink",   docunlink,  0, 0, NULLCHAR,
#endif
    "setinfo",  docinfo,    0, 0, NULLCHAR,
#ifdef AX25
    "t4",       doct4,      0, 0, NULLCHAR,
#endif
    "tdisc",    dotdisc,    0, 0, NULLCHAR,
    "umaxq",    doumaxq,    0, 0, NULLCHAR,
#ifdef XCONVERS
    "xlink",    docxlink,   0, 0, NULLCHAR,
#endif
    NULLCHAR,
};

/* Multiplexer for top-level convers command */
int
doconvers(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return subcmd(Ccmds,argc,argv,p);
}

int
doconvcmd(s)
char *s;
{
    struct cmds *cmdptr;
    int i;
    rip(s);
    if (cmdparse(Ccmds,s,NULL)) {
        tprintf("Commands available:\n");
        i = 0;
        for (cmdptr = Ccmds; cmdptr->name != NULLCHAR; cmdptr++) {
            i += strlen(cmdptr->name);
            if (i>80) {
                tprintf("\n");
                i = strlen(cmdptr->name) + 1;
            } else if (i<80) {
                tprintf(" ");
                i += 1;
            }
            tprintf(cmdptr->name);
        }
        tprintf("\n***\n");
    }
}

#ifdef AX25
/* Display or change our AX.25 conference call */
static int
doconfcall(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    char tmp[AXBUF];

	if(argc < 2){
        tprintf("%s\n",pax25(tmp,Ccall));
		return 0;
	}
    if(setcall(Ccall,argv[1]) == -1)
		return -1;
    return 0;
}

int32 CT4init = 7200;   /* 2 hours default */

/* Set link redundancy timer */
static int
doct4(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong(&CT4init,"Conf. redundancy timer (sec)",argc,argv);
}
#endif /* AX25 */

int32 CMaxwait = MAX_WAITTIME;

/* Set maxwait time for timed out links */
static int
docmaxwait(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong(&CMaxwait,"Re-link max wait (sec)",argc,argv);
}

int32 HMaxQ = 5*1024L;

/* Set maxwait time for timed out links */
static int
dohmaxq(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong(&HMaxQ,"Max. Host Queue (bytes)",argc,argv);
}

int UMaxQ = 1024L;

/* Set max qlimit for user links */
static int
doumaxq(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setint(&UMaxQ,"Max. User Queue (bytes)",argc,argv);
}

int32 Ctdiscinit = 0;

/* Set convers redundancy timer */
static int
dotdisc(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong(&Ctdiscinit,"redundancy timer (sec)",argc,argv);
}

static int
dochostname(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    if(argc == 1)
        tprintf("%s\n",Chostname);
    else {
        strncpy(Chostname,argv[1],NAMELEN);
        Chostname[CNAMELEN] = '\0';
    }
    return 0;
}

static int
docinfo(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setbool(&allow_info_updates,"Allow users to change info file",argc,argv);
}

static int
docfilter(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    int32 addr;
    struct filter_link *fl;

#ifdef NOS
    if(argc == 1) {
        if(Filterlinks) {
            tprintf("Mode is: %s\n", FilterMode ? "Accept" : "Refuse");
            for(fl=Filterlinks;fl;fl=fl->next)
                tprintf("%s\n",inet_ntoa(fl->addr));
        }
        return 0;
    }
    if(!stricmp(argv[1],"mode")) {
        if(argc == 2)
            tprintf("Mode is: %s\n", FilterMode ? "Accept" : "Refuse");
        else {
            if(*argv[2] == 'a' || *argv[2] == 'A')
                FilterMode = 1;
            else
                FilterMode = 0;
        }
        return 0;
    }
    if((addr = resolve(argv[1])) == 0) {
        tprintf(Badhost,argv[1]);
        return 1;
    }
    /* check to see if we already have this in the list */
    for(fl=Filterlinks;fl;fl=fl->next)
        if(fl->addr == addr)
            return 0;       /* already have this one ! */

    /* Seems like a new one */
    fl = (struct filter_link *)callocw(1,sizeof(struct filter_link));
    fl->addr = addr;
    fl->next = Filterlinks;
    Filterlinks = fl;
#endif
    return 0;
}

#ifdef LINKS
static int
doclinks(argc,argv,p,use_lzw)
int argc;
char *argv[];
void *p;
int use_lzw;
{
    int32 addr;
    struct permlink *pl;

    if(argc == 1) {
        for(pl=permlinks;pl;pl=pl->next)
#ifdef XCONVERS
            tprintf("%10s: %s %s\n",pl->name,inet_ntoa(pl->addr), pl->use_lzw ?
              "XCONVERS" : "CONVERS");
#else
            tprintf("%10s: %s\n",pl->name,inet_ntoa(pl->addr));
#endif
        return 0;
    }
    if((addr = resolve(argv[1])) == 0) {
        tprintf(Badhost,argv[1]);
        return 1;
    }
    /* check to see if we already have a link to such animal,
     * this happens when we stop and restart the server - WG7J
     */
    for(pl=permlinks;pl;pl=pl->next)
        if(pl->addr == addr)
            return 1;       /* already have this one ! */

    /* Seems like a new link ! Go add it */
    pl = (struct permlink *)callocw(1,sizeof(struct permlink ));
    pl->addr = addr;
#ifdef XCONVERS
    pl->use_lzw = use_lzw;
#endif
    pl->next = permlinks;
    permlinks = pl;
    if(argc > 2) {
        strncpy(pl->name,argv[2],NAMELEN);
    } else
        strncpy(pl->name,argv[1],NAMELEN);
    update_permlinks(pl->name,NULLCONNECTION);

    return 0;
}
static int
doclink(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return doclinks(argc,argv,p,0);
}


#ifdef XCONVERS
static int
docxlink(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return doclinks(argc,argv,p,1);
}
#endif

static int
docunlink(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    int fd;
    int32 addr;
    struct permlink *pl, *pls;

    if(argc == 1) {
        pl=permlinks;
        permlinks=NULLPERMLINK;
        while(pl) {
            tprintf("Unlinking %s\n",inet_ntoa(pl->addr));
            send_link_change_msg(pl->name,"unlinked by sysop");
            shutdown(pl->fd,2);
            close_s(pl->fd);
            pls=pl->next;
            free(pl);
            pl=pls;
        }
        return 0;
    }
    if((addr = resolve(argv[1])) == 0) {
        tprintf(Badhost,argv[1]);
        return 1;
    }

    pls=NULLPERMLINK;
    for(pl=permlinks;pl;pls=pl,pl=pl->next)
        if(pl->addr == addr) {
            if (pls)
                pls->next = pl->next;
            else
                permlinks = pl->next;
            send_link_change_msg(pl->name,"unlinked by sysop");
            tprintf("Unlinking %s\n",inet_ntoa(pl->addr));
            shutdown(pl->fd,2);
            close_s(pl->fd);
            free(pl);
            return 0;
        }

    tprintf("Not linked to %s\n",argv[1]);
    return 0;
}
#endif

#ifdef NOS
static int
dociface(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setflag(argc,argv[1],IS_CONV_IFACE,argv[2]);
}
#endif

#ifdef LINKS

void
try_permlinks()
{
    int s,x;
    register struct permlink *p;
#ifdef NOS
    struct sockaddr_in cport;
#endif
    time_t currtime;
  
        for(p = permlinks; p; p = p->next) {
            currtime = time(&currtime);
            if(p->convection || p->retrytime > currtime)
                continue;
            p->tries++;
            p->waittime <<= 1;
            if(p->waittime > CMaxwait)
                p->waittime = CMaxwait;
            p->retrytime = p->waittime + currtime;
#ifdef XCONVERS
            x = p->use_lzw;
#else
            x = 0;
#endif

#ifdef NOS
            cport.sin_family = AF_INET;
            cport.sin_port = x ? IPPORT_XCONVERS : IPPORT_CONVERS;
            cport.sin_addr.s_addr = p->addr; /* we've resolved this earlier */
            if((s = socket(AF_INET,SOCK_STREAM,0)) == -1)
                continue;
            if(connect(s,(char *)&cport,SOCKSIZE) == -1) {
                shutdown(s,2);  /* to make sure it doesn't linger around */
                close_s(s);     /* WG7J - 9207228 */
                continue;
            }
            p->fd = s;
            if(newproc("permlink",CDAEMONSTACK,
#ifdef XCONVERS
               x ? xconv_incom : conv_incom,
#else
               conv_incom,
#endif
               s,(void *)TELNET,NULL,0) == NULLPROC){
                shutdown(s,2);  /* blow it out of the water :-) */
                close_s(s);
            }
#else
            p->fd = startcliaddr(AF_INET,p->addr,x ? IPPORT_XCONVERS : IPPORT_CONVERS);
            new_conv(p->fd);
#endif
        }
        /* This is now called from the garbage collect process, such that it
         * checks even when the linker process isn't running! - WG7J
        check_buffer_overload();
        */
}

#ifdef NOS
void
connect_permlinks(a,b,c)
int a;
void *b;
void *c;
{
    int s,x;
    register struct permlink *p;
    struct sockaddr_in cport;
    time_t currtime;
  
    for(;;) {
        pause(15000L);
        try_permlinks();
        /* This is now called from the garbage collect process, such that it
         * checks even when the linker process isn't running! - WG7J
        check_buffer_overload();
        */
    }
}

/* Start up convers server */
int
conv1(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	struct sockaddr_in lsocket;
	int s;

	if(Sconv != -1){
		return 0;
	}
	psignal(Curproc,0); 		/* Don't keep the parser waiting */
	chname(Curproc,"Convers listener");
#ifdef CHANNELNAMES
#ifdef XCONVERS
	if (Sxconv == -1)
	    read_channels();
#endif
#endif

	lsocket.sin_family = AF_INET;
	lsocket.sin_addr.s_addr = INADDR_ANY;
	lsocket.sin_port = (argc < 2) ? IPPORT_CONVERS : atoi(argv[1]);

	Sconv = socket(AF_INET,SOCK_STREAM,0);
	bind(Sconv,(char *)&lsocket,sizeof(lsocket));
	listen(Sconv,1);
	for(;;){
		if((s = accept(Sconv,NULLCHAR,(int *)NULL)) == -1)
			break;			/* Service is shutting down */
        /* Low mem check now done in tcpin.c - WG7J */
        /* Spawn a server */
        if(newproc("conversd",CDAEMONSTACK,conv_incom,s,(void *)TELNET,(void *)0,0) == NULLPROC)
            close_s(s);
	}
#ifdef LINKS
    if(Linker)
#ifdef XCONVERS
      if(Sxconv == -1)
#endif
        killproc(Linker);
#endif
	return 0;
}

#ifdef XCONVERS
/* Start up xconvers server */
int
xconv1(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	struct sockaddr_in lsocket;
	int s;

	if(Sxconv != -1){
		return 0;
	}
	psignal(Curproc,0); 		/* Don't keep the parser waiting */
	chname(Curproc,"XConv listener");
#ifdef CHANNELNAMES
        if (Sconv == -1)
	    read_channels();
#endif
        lsocket.sin_family = AF_INET;
	lsocket.sin_addr.s_addr = INADDR_ANY;
	lsocket.sin_port = (argc < 2) ? IPPORT_XCONVERS : atoi(argv[1]);

	Sxconv = socket(AF_INET,SOCK_STREAM,0);
	bind(Sxconv,(char *)&lsocket,sizeof(lsocket));
	listen(Sxconv,1);
	for(;;){
		if((s = accept(Sxconv,NULLCHAR,(int *)NULL)) == -1)
			break;			/* Service is shutting down */
        /* Low mem check now done in tcpin.c - WG7J */
        /* Spawn a server */
        if(newproc("xconversd",2048,conv_incom,s,(void *)TELNET,(void *)1,0) == NULLPROC)
            close_s(s);
	}
#ifdef LINKS
    if(Linker && Sconv == -1)
        killproc(Linker);
#endif
	return 0;
}
#endif
#endif
#endif
#endif /* CONVERS */
