/* convers server - based on conversd written by DK5SG
 * ported to WNOS by DB3FL - 9109xx/9110xx
 * ported to NOS by PE1NMB - 920120
 * Mods by PA0GRI
 * Cleanup, and additional mods by WG7J
 * Additions by N2RJT & WA2ZKD
 */
/* Convers server main program */
#include <time.h>
#include <ctype.h>
#include <string.h>
#ifdef  UNIX
#include <sys/types.h>
#include <sys/stat.h>
#endif
#ifdef MSDOS
#include <io.h>
#endif
#include "global.h"
#ifdef NOS
#include <alloc.h>
#else
#include "sockserv.h"
#define CONVERS
#ifdef UNIX
#include <signal.h>
#include <unistd.h>
#endif
#endif
#ifdef CONVERS
#include "cmdparse.h"
#include "convers.h"
#ifdef NOS
#include "mailbox.h"
#include "netuser.h"
#include "pktdrvr.h"
#include "timer.h"
#include "usock.h"
#include "socket.h"
#include "session.h"
#include "files.h"
#include "mailutil.h"
#ifdef LZW
#include "lzw.h"
#endif
#endif
#include <stdio.h>

#include "convcmd.h"
#include "convsubr.h"

char Badhost[] = "Unknown host %s\n";

char *Months[] = {"Jan","Feb","Mar","Apr","May","Jun",
                 "Jul","Aug","Sep","Oct","Nov","Dec"};

char *Cinfo = NULL;
char *Cinfobak = NULL;
char *Channelfile = NULL;
char *password = NULL;
char *autoexec = NULL;

char Chostname[CNAMELEN+1];
struct convection *convections;
struct permlink *permlinks;
int allow_info_updates;
struct filter_link *filter_links;
int FilterMode;
int UMaxQ;
int32 HMaxQ;

void rip(s)
register char *s;
{
    register char *cp;

    if ((cp = strchr(s,'\n')) != NULLCHAR)
        *cp = '\0';
}

void login(int s)
{
    struct convection *cp;

    new_conv(s,&cp);
}

#ifdef LINKS
void periodic_activity(int signum)
{
    signal(SIGALRM,&periodic_activity);
    alarm(15L);

    try_permlinks();
}
#endif

void source_file(name);

main(argc,argv)
int argc;
char *argv[];
/* Parameters: 
** -ppassword for sysop command, default is no password required
being implemented as we speak:
** -ffilename for autoexec file, default is no autoexec file
** -cchanfile for channel names, default is no channel names
** -ddatafile for user data,     default is no saved user data
*/
{
    int s,i;
    struct convection *cp;
    char buf[LINELEN];

    gethostname(Chostname,CNAMELEN);

    for (i=1; i<argc; i++) {
        if (argv[i][0] == '-') {
            switch (argv[i][1]) {
                case 'p': password = strdup(argv[i]+2); break;
                case 'f': autoexec = strdup(argv[i]+2); break;
                case 'c': Channelfile = strdup(argv[i]+2); break;
                case 'd': Cinfo = strdup(argv[i]+2);
                          Cinfobak = (char *) malloc(strlen(Cinfo)+4);
                          strcpy(Cinfobak,Cinfo);
                          strcat(Cinfobak,".bak");
                          break;
            }
        }
    }

    if (autoexec != NULL) {
        /* open and parse the file */
        source_file(autoexec);
    }

    startup(IPPORT_CONVERS,login);
#ifdef LZW
    startup(IPPORT_XCONVERS,xlogin);
#endif
    convinit();
    
#ifdef LINKS
    periodic_activity(0);
#endif

    while (1) {
        if (recvline(&s, buf, LINELEN) < 0) {
	    cp = convection_of(s);
	    bye_command(cp);
        } else {
	    cp = convection_of(s);
	    if (cp!=NULLCONNECTION) {
	        strcpy(cp->ibuf, buf);
	        process_a_command (cp);
	    }
        }
    }
}

void source_file(name)
char *name;
{
    FILE *f;
    char line[80];
    if ((f = fopen(name,"r"))==NULL) {
        perror(name);
    } else {
        while (fgets(line,80,f)!=NULL)
            doconvcmd(line);
        fclose(f);
    }
}

#endif
