#define CHANNELNAMES 1
#define LINKS 1    
#define space   1
#define CALLCHECK 1

extern int Sconv;
#ifdef XCONVERS
extern int Sxconv;
#endif

#define IPPORT_CONVERS 3600
#define IPPORT_XCONVERS 3601

extern char Chostname[CNAMELEN+1];

/* The convers daemon stack needs to be AT LEAST 4 times the LINELEN !
 * since quiet a few of the commands have local vars of size 2 or 3 * LINELEN.
 */
#define CDAEMONSTACK 2048
#define CLINKSTACK 1024
#define MAX_WAITTIME	(60*60*3)
#define NAMELEN 10
#define LINELEN 256

struct convection {
	int  type;			/* Connection type */
#define CT_UNKNOWN      0
#define CT_USER         1
#define CT_HOST         2
#define CT_CLOSED       3
    char  name[NAMELEN+1];         /* Name of user or host */
    char  host[NAMELEN+1];         /* Name of host where user is logged on */
	struct convection *via;		/* Pointer to neighbor host */
    char *data;                 /* room for some personal data */
    int channel;            /* Channel number */
	int32 time;			/* Connect time */
    int maxq;           /* Maximum outstanding data before link reset */
	int locked;			/* Set if mesg already sent */
	int fd;				/* Socket descriptor */
    int flags;          /* User flags */
#define CLOSE_SOCK  1
#define USE_SOUND   2
#define USE_LZW     4
#define IS_SYSOP    8
#define IS_SYSOP_CHALLENGE 16
    /* This buffer is only needed for local users; a lot of space is wasted
     * for users from other hosts (256 bytes per user!). Fixed 930728 - WG7J
     * char ibuf[LINELEN];
     */
    char *ibuf;                      /* Input buffer */
    unsigned long received;          /* Number of bytes received */
    unsigned long xmitted;           /* Number of bytes transmitted */
	struct convection *next;	/* Linked list pointer */
};
extern struct convection *convections;

#define CM_UNKNOWN	(1 << CT_UNKNOWN)
#define CM_USER		(1 << CT_USER)
#define CM_HOST		(1 << CT_HOST)
#define CM_CLOSED	(1 << CT_CLOSED)

#define NULLCONNECTION	((struct convection *) 0)

struct permlink {
    char name[NAMELEN+1];   /* Name of link */
    int32 addr;             /* address to link to */
#ifdef XCONVERS
    int use_lzw;
#endif
	struct convection *convection;	/* Pointer to associated connection */
    int32 statetime;        /* Time of last (dis)connect */
	int  tries;			/* Number of connect tries */
	int32 waittime;			/* Time between connect tries */
	int32 retrytime;		/* Time of next connect try */
	int fd;				/* socket descriptor */
	struct permlink *next;		/* Linked list pointer */
};
#define NULLPERMLINK ((struct permlink *) 0)
extern struct permlink *permlinks;

extern int allow_info_updates;

struct filter_link {
    struct filter_link *next;
    int32 addr;
};
#define NULLFL ((struct filter_link *) 0)
extern struct filter_link *filter_links;
extern int FilterMode;
extern int UMaxQ;
extern int32 HMaxQ;

extern char *Cinfo;
extern char *Cinfobak;
extern char *Channelfile;
extern char *password;
extern char *autoexec;
